#property copyright "Dmitry Yakovlev, Russia,Omsk WM R865705290089"
#property link      "http://fehu.b13.su/  dmitryyakv@yandex.ru  ICQ: 11-065-106"

extern double  MinLot=0.01;
extern double  MaxLot=1.00;
extern int     MartMode=0;
extern string  _tf="TimeFrame";
extern int     TF=60;
extern string  _mtr="Metro";
extern int     PeriodRSI=14;
extern int     StepSizeFast=5;
extern int     StepSizeSlow=15;
extern string  _st="TakeProfit/StopLoss";
extern int     TP = 0;
extern int     SL = 0;
extern string  _tr="Trailing (0-no/1-yes)";
extern int     UseTral=0;
extern int     trldistance=15;
extern int     trlstep=5;
extern int     Magic=123404321;
//===================================================================
datetime ta=0;
double Lots=0.01;

void init()
{
   Lots=MinLot;
   if(Digits==3 || Digits==5)
   {
      SL=SL*10;
      TP=TP*10;
      trldistance=trldistance*10;
      trlstep=trlstep*10;
   }
   Magic=Magic+Period();
   ta=Time[0];
}

void deinit()
{
}

void start()
{
   int      i,j,signal,total,signal_close;
   double   tmp;
   int      StopLevel=MarketInfo(Symbol(),MODE_STOPLEVEL);
   double   s0,s1,s2,f0,f1,f2;
   //==============================================================

   if(ta==Time[0]) return;
   ta=Time[0];
   
   f0=iCustom(Symbol(),TF,"metro",PeriodRSI,StepSizeFast,StepSizeSlow,1,0);
   f1=iCustom(Symbol(),TF,"metro",PeriodRSI,StepSizeFast,StepSizeSlow,1,1);
   f2=iCustom(Symbol(),TF,"metro",PeriodRSI,StepSizeFast,StepSizeSlow,1,2);

   s0=iCustom(Symbol(),TF,"metro",PeriodRSI,StepSizeFast,StepSizeSlow,2,0);
   s1=iCustom(Symbol(),TF,"metro",PeriodRSI,StepSizeFast,StepSizeSlow,2,1);
   s2=iCustom(Symbol(),TF,"metro",PeriodRSI,StepSizeFast,StepSizeSlow,2,2);
   
   signal=0;
   if(f0>s0 && f1>=s1 && f2<s2) signal=+1;
   if(f0<s0 && f1<=s1 && f2>s2) signal=-1;

   signal_close=0;
   if(f0>s0 && f1>=s1 && f2<s2) signal_close=+1;
   if(f0<s0 && f1<=s1 && f2>s2) signal_close=-1;

   //============================================================================
   //   
   total=GetOrdTotal();
   if(total>0)
   {
      //    
      if(signal_close!=0)
      {
         for(i=0;i<OrdersTotal();i++)
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if((OrderSymbol()==Symbol()) && (Magic==OrderMagicNumber()))
         {
            if(OrderType()==OP_BUY  && (signal_close==-1) ) Close_Buy();
            if(OrderType()==OP_SELL && (signal_close==+1) ) Close_Sell();
         }
      }
      
      if(UseTral==1)
      {
         for(i=0;i<OrdersTotal();i++)
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if((OrderSymbol()==Symbol()) && (Magic==OrderMagicNumber()) && (OrderType()==OP_BUY || OrderType()==OP_SELL))
         {
            TrailingStairs(OrderTicket(),trldistance,trlstep);
         }
      }
   }
   //============================================================================
   //   
   total=GetOrdTotal();
   if(total==0)
   {
      if(signal!=0)
      {
         int cntloss=0;
         for(i=OrdersHistoryTotal()-1;i>=0;i--)
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY) && OrderMagicNumber()==Magic && OrderSymbol()==Symbol())
         {
            if(OrderProfit()>=0) break;
            if(OrderProfit()<0) cntloss++;
         }
         Print("cntloss=",cntloss);
         Lots=MinLot;
         if(cntloss>0)
         {
            if(MartMode==0) Lots=MinLot*MathPow(2,cntloss);
            if(MartMode==1) Lots=MinLot*cntloss;
         }
      }
      if(Lots>MaxLot) Lots=MaxLot;
      if(signal==+1) Buy(TP,SL,0); // 
      if(signal==-1) Sell(TP,SL,0); // 
   }
   //============================================================================
   // 
}


//+------------------------------------------------------------------+
void Sell(double TP, double SL,int m=0)
{ 
   double mylots;
   double tp=0,sl=0;
   
   mylots=MathMax(MarketInfo(Symbol(),MODE_MINLOT),NormalizeDouble(Lots,2));
   
   if(m==0)
   {
      if(SL!=0) sl=NormalizeDouble(Bid+SL*Point,Digits);
      if(TP!=0) tp=NormalizeDouble(Ask-TP*Point,Digits);
   }
   else if(m==1)
   {
      sl=SL; tp=TP;
   }
   
   int tk=0;
   if(mylots>0)
   {
      tk=OrderSend(Symbol(),OP_SELL,mylots,NormalizeDouble(Bid,Digits),10,NormalizeDouble(sl,Digits),NormalizeDouble(tp,Digits),"",Magic,0,Red);
   }
   return;
}
//+------------------------------------------------------------------+
void Buy(double TP, double SL,int m=0)
{
   double mylots;
   double tp=0,sl=0;
   
   mylots=MathMax(MarketInfo(Symbol(),MODE_MINLOT),NormalizeDouble(Lots,2));

   if(m==0)
   {
      if(SL!=0) sl=NormalizeDouble(Ask-SL*Point,Digits);
      if(TP!=0) tp=NormalizeDouble(Bid+TP*Point,Digits);
   }
   else if(m==1)
   {
      sl=SL; tp=TP;
   }
   
   int tk=0;
   if(mylots>0)
   {
      tk=OrderSend(Symbol(),OP_BUY,mylots,NormalizeDouble(Ask,Digits),10,NormalizeDouble(sl,Digits),NormalizeDouble(tp,Digits),"",Magic,0,Blue);
   }
   return;
}
//+------------------------------------------------------------------+
void Close_Buy()
{
   OrderClose(OrderTicket(),OrderLots(),Bid,5,Red);
}
//+------------------------------------------------------------------+
void Close_Sell()
{
   OrderClose(OrderTicket(),OrderLots(),Ask,5,Red);
}
// ===================================================================+
int GetOrdTotal(int cmd=-1)
{
   int i=0,ret=0;
   
   for(i=0;i<OrdersTotal();i++)
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
   if( (cmd==-1 || OrderType()==cmd) && OrderSymbol()==Symbol() && (Magic==OrderMagicNumber()) ) ret++;
   
   return(ret);
}

void TrailingStairs(int ticket,int trldistance,int trlstep)
   {  
   double nextstair; //   ,     

   //   
   if (/*(trldistance<MarketInfo(Symbol(),MODE_STOPLEVEL)) ||*/ (trlstep<1) || (trldistance<trlstep) || (ticket==0) || (!OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)))
      {
      Print("  TrailingStairs()  -     .");
      return(0);
      } 
   
   //    (OP_BUY)
   if (OrderType()==OP_BUY)
      {
      // ,       
      //       0 ( ),    =   + trldistance + 
      if ((OrderStopLoss()==0) || (OrderStopLoss()<OrderOpenPrice()))
      nextstair = OrderOpenPrice() + trldistance*Point;
         
      //    =   + trldistance + trlstep + 
      else
      nextstair = OrderStopLoss() + trldistance*Point;

      //    (Bid) >= nextstair      ,  
      if (Bid>=nextstair)
      if ((OrderStopLoss()==0) || (OrderStopLoss()<OrderOpenPrice())) 
      OrderModify(ticket,OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() + trlstep*Point,Digits),OrderTakeProfit(),OrderExpiration());
      else
      OrderModify(ticket,OrderOpenPrice(),NormalizeDouble(OrderStopLoss() + trlstep*Point,Digits),OrderTakeProfit(),OrderExpiration());
      }
      
   //    (OP_SELL)
   if (OrderType()==OP_SELL)
      { 
      // ,       
      //       0 ( ),    =   + trldistance + 
      if ((OrderStopLoss()==0) || (OrderStopLoss()>OrderOpenPrice()))
      nextstair = OrderOpenPrice() - (trldistance + MarketInfo(Symbol(),MODE_SPREAD))*Point;
      
      //    =   + trldistance + trlstep + 
      else
      nextstair = OrderStopLoss() - (trldistance + MarketInfo(Symbol(),MODE_SPREAD))*Point;
       
      //    () >= nextstair      ,  
      if (Ask<=nextstair)
      if ((OrderStopLoss()==0) || (OrderStopLoss()>OrderOpenPrice()))
      OrderModify(ticket,OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() - (trlstep + MarketInfo(Symbol(),MODE_SPREAD))*Point,Digits),OrderTakeProfit(),OrderExpiration());
      else
      OrderModify(ticket,OrderOpenPrice(),NormalizeDouble(OrderStopLoss()- (trlstep + MarketInfo(Symbol(),MODE_SPREAD))*Point,Digits),OrderTakeProfit(),OrderExpiration());
      }      
   }
//+------------------------------------------------------------------+

